/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.security.*;
import java.util.*;
import java.security.cert.*;
import javax.net.ssl.*;
import java.security.*;
import java.security.spec.*;
import javax.crypto.*;
import javax.crypto.spec.*;

public class Client extends Thread {
  Socket sck;
  InputStream is;
  OutputStream os;

  DataInputStream dis;
  DataOutputStream dos;

  public Client(Socket sck) throws Throwable {
   this.sck=sck;
   is=sck.getInputStream();
   os=sck.getOutputStream();

   dis=new DataInputStream(is);
   dos=new DataOutputStream(os);
  }

  public String extract_url(String req) throws Throwable {
   String[] tokens=req.split(" ");
   String url=tokens[1];

   return url;
  }

  public Request receive_request() {
   Request req=null;

   try {
    LinkedList headers=new LinkedList();
    byte data[]=null;

    String line=dis.readLine();

    if (line==null) {
     return null;
    }

    String req_line=line;

    String url=extract_url(req_line);

    int len=-1;
    boolean chunked=false;

    while(line!=null) {
     if (line.isEmpty()) break;

     headers.add(line);

     if (line.startsWith("Content-Length:")) {
      String s=line.substring(16,line.length());
      len=Integer.parseInt(s);
     } else

     if (line.startsWith("Transfer-Encoding: chunked")) {
      chunked=true;
     }

     line=dis.readLine();
    }

    ByteArrayOutputStream baos=new ByteArrayOutputStream();

    if (chunked) {
     line=dis.readLine();

     baos.write(line.getBytes());

     len=Integer.parseInt(line.trim(),0x10);

     byte buf[]=new byte[len];
     dis.read(buf,0,len);

     baos.write(buf,0,len);
    } else

    if (len>0) {
     byte buf[]=new byte[len];
     dis.read(buf,0,len);

     baos.write(buf,0,len);
    }

    data=baos.toByteArray();

    req=new Request(url,headers,data);
   } catch(Throwable t) {
     t.printStackTrace();
   }

   return req;
  }  

  public Response process_request(Request req) throws Throwable {
   RequestHandler rh=new RequestHandler();
   return rh.process_request(req);
  }

  public void send_response(Response resp) {
   try {
    LinkedList headers=resp.headers;
    byte data[]=resp.body;

    ByteArrayOutputStream baos=new ByteArrayOutputStream();
    DataOutputStream rdos=new DataOutputStream(baos);

    boolean chunked=false;

    String res_code=(String)headers.get(0);

    String line=res_code+"\n";
  
    for(int i=1;i<headers.size();i++) {
     String hdr=(String)headers.get(i);
     hdr=hdr.trim();

     if (hdr.startsWith("Location: https")) {
      hdr="Location: http"+hdr.substring(15,hdr.length());
     }

     line+=(hdr+"\n");

     if (hdr.startsWith("Transfer-Encoding: chunked")) {
      chunked=true;
     }
    }

    line+="\n";

    if (chunked) {
      line+=Integer.toHexString(data.length)+"\n";
    }

    rdos.writeBytes(line);

    rdos.write(data,0,data.length);

    rdos.writeBytes("0\n\n");
    rdos.flush();

    data=baos.toByteArray();

    dos.write(data);
    dos.flush();              
   } catch(Throwable t) {
     t.printStackTrace();
   }
  }

  public void run() {
   try {
    while(true) {
     Request req=receive_request();
     if (req==null) break;

     Response resp=process_request(req);
     if (resp==null) break;

     send_response(resp);
    }
   } catch(Throwable t) {
    t.printStackTrace();
   }
  }  
}
