/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.net.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;

public class RequestHandler {
  HttpURLConnection conn;

  InputStream is;
  OutputStream os;

  DataInputStream dis;
  DataOutputStream dos;

  public void error(String s) {
   System.out.println("error: "+s);
   System.exit(1);
  }

  public byte[] unpack(byte data[],int unpack_len) {
   byte res[]=null;

   try {
    Inflater inflater=new Inflater();
    inflater.setInput(data);

    data=new byte[unpack_len];
    int len=inflater.inflate(data);
    inflater.end();

    res=data;
   } catch (Throwable t) {} 

   return res;
  }

  public byte[] pack(byte data[]) {
   byte res[]=null;

   try {
    Deflater deflater=new Deflater();
    deflater.setInput(data);
    deflater.finish();

    ByteArrayOutputStream baos=new ByteArrayOutputStream();

    byte buf[]=new byte[data.length];

    while(!deflater.finished()) {
     int len=deflater.deflate(buf);
     baos.write(buf,0,len);
    }

    res=baos.toByteArray();
   } catch (Throwable t) {} 

   return res;
  }

  public byte[] pack_request(Request req) throws Throwable {
   byte data[]=null;

   ByteArrayOutputStream baos=new ByteArrayOutputStream();
   DataOutputStream rdos=new DataOutputStream(baos);

   //request url
   String url=req.url.trim();

   System.out.println("req: "+url);

   String line=url+"\n";

   //request headers
   line+=req.headers.size()+"\n";

   for(int i=0;i<req.headers.size();i++) {
    String hdr=(String)req.headers.get(i);
    line+=hdr.trim()+"\n";
   }

   rdos.writeBytes(line);

   //request body
   line=""+req.body.length+"\n";
   rdos.writeBytes(line);
   rdos.write(req.body,0,req.body.length);

   rdos.flush();

   data=baos.toByteArray();

   byte packed[]=pack(data);

   baos=new ByteArrayOutputStream();
   rdos=new DataOutputStream(baos);

   int unpack_len=data.length;
   int pack_len=packed.length;

   line=unpack_len+"\n";
   line+=pack_len+"\n";

   rdos.writeBytes(line);
   rdos.write(packed);
   rdos.flush();

   data=baos.toByteArray();

   return data;
  }

  public Response unpack_response(byte data[]) {
   Response resp=null;

   try {
    ByteArrayInputStream bais=new ByteArrayInputStream(data);
    DataInputStream rdis=new DataInputStream(bais);

    String line=rdis.readLine();
    if (line==null) return null;

    int unpack_len=Integer.parseInt(line.trim());

    line=rdis.readLine().trim();
    int pack_len=Integer.parseInt(line);

    byte packed[]=new byte[pack_len];
    rdis.readFully(packed);
 
    data=unpack(packed,unpack_len);

    bais=new ByteArrayInputStream(data);
    rdis=new DataInputStream(bais);

    LinkedList headers=new LinkedList();

    line=rdis.readLine();
    if (line==null) return null;

    int hdrnum=Integer.parseInt(line.trim());

    for(int i=0;i<hdrnum;i++) {
     line=rdis.readLine();
     headers.add(line);
    }      

    line=rdis.readLine().trim();
    int len=Integer.parseInt(line);

    byte body[]=new byte[len];
    rdis.readFully(body);

    resp=new Response(headers,body,0);     
   } catch (Throwable t) { 
    t.printStackTrace();   
   } 

   return resp;
  }

  public byte[] send_request(byte data[]) {
   byte resp[]=null;

   try {
    URL url=new URL(Proxy.URL);

    conn=(HttpURLConnection)url.openConnection();
    conn.setRequestMethod("POST");

    conn.setRequestProperty("Content-Type","application/x-java-serialized-object");
    conn.setRequestProperty("Authorization","Basic "+Proxy.AUTHORIZATION);

    conn.setDoInput(true);
    conn.setDoOutput(true);

    conn.setRequestProperty("Content-Length", (new StringBuilder()).append("").append(data.length).toString());

    OutputStream os=conn.getOutputStream();
    os.write(data);
    os.flush();
    os.close();

    int res_code=conn.getResponseCode();

    InputStream is=conn.getInputStream();
    DataInputStream dis=new DataInputStream(is);

    int size=conn.getContentLength();

    resp=new byte[size];
    dis.readFully(resp);

    conn=null;
   } catch(Throwable t) {
    t.printStackTrace();
   }

   return resp;
  }

  public Response process_request(Request req) {
   Response resp=null;

   try {
    byte data[]=pack_request(req);
    data=send_request(data);

    resp=unpack_response(data);
   } catch(Throwable t) {
    t.printStackTrace();
   }

   return resp;
  }
}
