package weblogic.deploy.internal.targetserver.datamanagement;

import java.io.*;
import java.util.List;
import weblogic.deploy.service.DataTransferRequest;

public abstract class DataTransferRequestImpl implements DataTransferRequest {

  protected DataTransferRequestImpl() {
  }

  public DataTransferRequestImpl(long requestId, List filePaths, String lockPath) {
    this.requestId=requestId;
    this.filePaths=filePaths;
    this.lockPath=lockPath;
  }

  public long getRequestId() {
    return requestId;
  }

  public List getFilePaths() {
    return filePaths;
  }

  public String getLockPath() {
    return lockPath;
  }

  public void writeExternal(ObjectOutput out) throws IOException {
    out.writeLong(requestId);
    out.writeObject(filePaths);
    out.writeObject(lockPath);
  }

  public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {
    requestId=in.readLong();
    filePaths=(List)in.readObject();
    lockPath=(String)in.readObject();
  }

  private static final long serialVersionUID = 0xf3b3205b1433d61cL;

  private long requestId;
  private List filePaths;
  private String lockPath;
}
