package weblogic.utils.io;

import java.io.*;

public final class DelegatingOutputStream extends FilterOutputStream {

    public DelegatingOutputStream(OutputStream out) throws IOException {
      super(out);
    }

    public OutputStream getDelegate() {
      return out;
    }

    public void setDelegate(OutputStream os) {
      out = os;
    }

    public void flush() throws IOException {
      super.flush();
    }

    public void write(byte b[], int off, int len) throws IOException {
      out.write(b, off, len);
    }
}
