/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;
import java.net.*;
import javax.net.ssl.*;
import java.security.*;
import java.security.cert.*;
import java.security.spec.*;
import javax.crypto.*;
import javax.crypto.spec.*;

public class WebUtils {

 public static class MyTrustManager implements X509TrustManager {
  public X509Certificate[] getAcceptedIssuers() {
   return null;
  }
  public void checkClientTrusted(X509Certificate[] certs,String authType) {
  }
  public void checkServerTrusted(X509Certificate[] certs,String authType) {
  }
 }

 public static class Request {
  public String url;
  public LinkedList headers;
  public byte body[];

  public Request(String url,LinkedList h,byte b[]) {
   this.url=url;
   this.headers=h;
   this.body=b;
  }
 }

 public static class Response {
  public LinkedList headers;
  public byte body[];
  public int res_code;

  public Response(LinkedList h,byte b[],int res) {
   this.headers=h;
   this.body=b;
   this.res_code=res;
  }
 }

 public static Object connect(String host,int port,boolean ssl) {
  Object sck=null;

  try {
   if (ssl) {
    TrustManager[] tmtab=new TrustManager[1];
    tmtab[0]=new MyTrustManager();
    SSLContext sc=SSLContext.getInstance("SSL");
    sc.init(null,tmtab,new SecureRandom());

    Object sf=sc.getSocketFactory();

    Class ctab[]=new Class[2];
    ctab[0]=Class.forName("java.lang.String");
    ctab[1]=Integer.TYPE;

    Class c=sf.getClass();
    Method m=c.getMethod("createSocket",ctab);
     
    Object args[]=new Object[2];
    args[0]=host;
    args[1]=new Integer(port);

    sck=m.invoke(sf,args);
   } else {
    Class c=Class.forName("java.net.Socket");

    Class ctab[]=new Class[2];
    ctab[0]=Class.forName("java.lang.String");
    ctab[1]=Integer.TYPE;

    Constructor con=c.getConstructor(ctab);

    Object args[]=new Object[2];
    args[0]=host;
    args[1]=new Integer(port);

    sck=con.newInstance(args);
   }
  } catch (Throwable t) {t.printStackTrace();} 

  return sck;
 }

 public static Response handle_direct_request(Request req,boolean ssl) {
  Response resp=null;

  try {
   String url=req.url;
   int idx=url.indexOf("://");
   if (idx==-1) return null;

   String path=url.substring(idx+3,url.length());
   if (path.isEmpty()) return null;

   idx=path.indexOf("/");
   if (idx==-1) return null;
  
   path=path.substring(idx,path.length());
   if (path.isEmpty()) return null;

   URL u=new URL(req.url);

   String host=u.getHost();
   int port=u.getPort();

   if (ssl) {
    if (port==80) port=443;
   }     

   Object sck=connect(host,port,ssl);

   Class c=sck.getClass();

   Method m=c.getMethod("getOutputStream",new Class[0]);
   OutputStream ros=(OutputStream)m.invoke(sck,new Object[0]);

   m=c.getMethod("getInputStream",new Class[0]); 
   InputStream ris=(InputStream)m.invoke(sck,new Object[0]);

   DataOutputStream rdos=new DataOutputStream(ros);
   DataInputStream rdis=new DataInputStream(ris);

   LinkedList headers=req.headers;

   String req_line=(String)headers.get(0);

   boolean isget=true;

   if (req_line.startsWith("POST")) {
    req_line="POST "+path+" HTTP/1.1\n";
    isget=false;
   } else {
    req_line="GET "+path+" HTTP/1.1\n";
   }

   String line=req_line;

   for(int i=1;i<headers.size();i++) {
    String hdr=(String)headers.get(i);
    hdr=hdr.trim();

    line+=(hdr+"\n");
   }

   line+="\n";

   rdos.writeBytes(line);

   if ((!isget)&&(req.body.length>0)) {
    rdos.write(req.body);
   }     

   rdos.flush();

   headers=new LinkedList();
   byte data[]=null;

   line=rdis.readLine();

   if (line==null) {
    return null;
   }

   String[] tokens=line.split(" ");
   int res_code=Integer.parseInt(tokens[1].trim());

   int len=-1;
   boolean chunked=false;

   while(line!=null) {
    if (line.isEmpty()) break;

    headers.add(line);

    if (line.startsWith("Content-Length:")) {
     String s=line.substring(16,line.length()).trim();
     len=Integer.parseInt(s);
    } else

    if (line.startsWith("Transfer-Encoding: chunked")) {
     chunked=true;
    }

    line=rdis.readLine();
   }

   ByteArrayOutputStream baos=new ByteArrayOutputStream();

   if (res_code!=200) {
    if (len>0) {
     byte buf[]=new byte[len];
     rdis.readFully(buf);

     baos.write(buf,0,len);
     data=baos.toByteArray();
    } else data=new byte[0];
   } else

   if (chunked) {
    while(true) {
     line=rdis.readLine().trim();
     if (line.isEmpty()) continue;
 
     len=Integer.parseInt(line,0x10);

     if (len<=0) break;

     byte buf[]=new byte[len];
     rdis.readFully(buf);

     baos.write(buf,0,len);
     data=baos.toByteArray();
    }
   } else

   if (len>0) {
    byte buf[]=new byte[len];
    rdis.readFully(buf);

    baos.write(buf,0,len);
    data=baos.toByteArray();
   } else data=new byte[0];
     
   resp=new Response(headers,data,res_code);

   c=sck.getClass();

   m=c.getMethod("close",new Class[0]);
   m.invoke(sck,new Object[0]);
  } catch (Throwable t) {t.printStackTrace();} 

  return resp;
 }

 public static void test(Request req,boolean ssl) {
  Response resp=null;

  try {
   String url=req.url;
   int idx=url.indexOf("://");

   String path=url.substring(idx+3,url.length());

   idx=path.indexOf("/");
  
   path=path.substring(idx,path.length());

   URL u=new URL(req.url);

   String host=u.getHost();
   int port=u.getPort();

   if (ssl) {
    if (port==80) port=443;
   }     

   Object sck=connect(host,port,ssl);

   Class c=sck.getClass();

   Method m=c.getMethod("getOutputStream",new Class[0]);
   OutputStream ros=(OutputStream)m.invoke(sck,new Object[0]);

   m=c.getMethod("getInputStream",new Class[0]); 
   InputStream ris=(InputStream)m.invoke(sck,new Object[0]);

   DataOutputStream rdos=new DataOutputStream(ros);
   DataInputStream rdis=new DataInputStream(ris);

   LinkedList headers=req.headers;

   String line="";

   for(int i=0;i<headers.size();i++) {
    String hdr=(String)headers.get(i);
    hdr=hdr.trim();

    line+=(hdr+"\n");
   }

   line+="\n";

   rdos.writeBytes(line);

   rdos.flush();

   headers=new LinkedList();
   byte data[]=null;

   line=rdis.readLine();

   while(line!=null) {
    if (line.isEmpty()) break;

System.out.println(line);

    headers.add(line);
    line=rdis.readLine();
   }

  } catch (Throwable t) {t.printStackTrace();} 
 }


 public static void set_header(HttpURLConnection conn,String line) {
  try {
   int idx=line.indexOf(":");
   if (idx>0) {
    String name=line.substring(0,idx);
    String val=line.substring(idx+1,line.length());
    val=val.trim();

    conn.setRequestProperty(name,val);
   }
  } catch (Throwable t) {}    
 }

 public static Response handle_proxy_request(Request req,boolean ssl) {
  Response resp=null;

  try {
   boolean isget=true;

   String url=req.url;

   if (ssl) {
    if (url.startsWith("http://")) {
     url="https://"+url.substring(7,url.length());
    }
   }
     
   HttpURLConnection rconn=(HttpURLConnection)(new URL(url)).openConnection();
   rconn.setInstanceFollowRedirects(false);

   LinkedList headers=req.headers;

   String req_line=(String)headers.get(0);

   if (req_line.startsWith("POST")) {
    isget=false;
    rconn.setRequestMethod("POST");
   } else {
    rconn.setRequestMethod("GET");
   }

   for(int i=1;i<headers.size();i++) {
    set_header(rconn,(String)headers.get(i));
   }

   rconn.setDoInput(true);

   if (isget) rconn.setDoOutput(false);
    else rconn.setDoOutput(true);

   if ((!isget)&&(req.body.length>0)) {
    OutputStream ros=rconn.getOutputStream();
    ros.write(req.body);
    ros.flush();
   }

   int res_code=-1;

   try {
    res_code=rconn.getResponseCode();
   } catch(FileNotFoundException e) {}

   int i=0;
   headers=new LinkedList();

   while(true) {
    String key=rconn.getHeaderFieldKey(i);
    String val=rconn.getHeaderField(i);

    if ((key==null)&&(val==null)) break;

    if (key==null) headers.add(val);
     else
    if (val==null) headers.add(key);
     else headers.add(key+": "+val);
    i++;
   }

   InputStream ris=null;

   if (res_code==200) ris=rconn.getInputStream();
    else ris=rconn.getErrorStream();

   DataInputStream rdis=new DataInputStream(ris);      

   int len=-1;
   boolean chunked=false;

   byte body[]=null;

   String line=rconn.getHeaderField("Content-Length");

   if (line!=null) {
    len=Integer.parseInt(line.trim());
   }

   line=rconn.getHeaderField("Transfer-Encoding");

   if (line!=null) {
    if (line.startsWith("chunked")) {
     chunked=true;
    } 
   }

   if (res_code==200) {      
    if (chunked) {
     ByteArrayOutputStream baos=new ByteArrayOutputStream();
     byte buf[]=new byte[8192];
 
     while(true) {
      int cnt=rdis.read(buf,0,buf.length);
      if (cnt==-1) break;
      baos.write(buf,0,cnt);
     }

     baos.flush();

     body=baos.toByteArray();
    } else {
     if (len>0) {
      body=new byte[len];
      rdis.readFully(body);
     } else body=new byte[0];
    }
   } else {
    if (len>0) {
     body=new byte[len];
     rdis.readFully(body);
    } else body=new byte[0];
   }

   resp=new Response(headers,body,res_code);
  } catch (Throwable t) {t.printStackTrace();} 

  return resp;
 }

 public static Response handle_request(Request req,boolean direct,boolean ssl) {
  Response resp=null;

  try {
   if (direct) resp=handle_direct_request(req,ssl);
    else resp=handle_proxy_request(req,ssl);
  } catch (Throwable t) {t.printStackTrace();} 

  return resp;
 }

}
