/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* WLSRMIDump servlet                                                         */
/* dumps OID table of registered RMI servers, RootNamingNode map and all      */
/* registered MBeans for a given Weblogic server instance                     */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.util.*;
import java.util.concurrent.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class WLSRMIDump extends HttpServlet {
 private static Object server=null;

 public static int LINESIZE = 16;

 public String pad(int lvl) {
  String s="";

  for(int i=0;i<2*lvl;i++) {
   s+=" ";
  }

  return s;
 }

 public void dump_namingnode(PrintWriter out,Object node,int lvl) {
  try {
   Class c=Class.forName("weblogic.jndi.internal.BasicNamingNode");

   Field f=c.getDeclaredField("map");
   f.setAccessible(true);

   ConcurrentHashMap map=(ConcurrentHashMap)f.get(node);

   Enumeration keys=map.keys();

   while(keys.hasMoreElements()) {
    Object key=keys.nextElement();

    Object val=map.get(key);

    out.println(pad(lvl)+"- ["+key+"] = "+val);
    out.println(pad(lvl+(key.toString().length()+4)/2)+"   "+val.getClass());

    if (val.getClass().getName().equals("weblogic.management.mbeanservers.compatibility.internal.RemoteMBeanServerImpl")) {
     server=val;
    }

    if (c.isAssignableFrom(val.getClass())) {
     dump_namingnode(out,val,lvl+1);
    }
   }

  } catch(Throwable t) {
   t.printStackTrace(out);
  }
 }

 public void doGet(HttpServletRequest req,HttpServletResponse resp) throws ServletException, IOException {
  PrintWriter out=resp.getWriter();

  try {
   resp.setContentType("text/plain");
   out.println("sm = "+System.getSecurityManager());

   out.println("---------------- OID TABLE ----------------");

   Class c=Class.forName("weblogic.rmi.internal.OIDManager");
   Method m=c.getMethod("getInstance",new Class[0]);

   Object oidm=m.invoke(null,new Object[0]);
   out.println(oidm);

   Field f=c.getDeclaredField("oidTable");
   f.setAccessible(true);

   Object oidTable=f.get(oidm);

   c=oidTable.getClass();
   m=c.getMethod("keys",new Class[0]);

   Enumeration keys=(Enumeration)m.invoke(oidTable,new Object[0]);

   Class ctab[]=new Class[1];
   ctab[0]=Integer.TYPE;

   m=c.getMethod("get",ctab);

   out.println("[oidTable]");

   Object res[]=new Object[2048];

   while(keys.hasMoreElements()) {
    Integer key=(Integer)keys.nextElement();

    Object args[]=new Object[1];
    args[0]=key;

    Object val=m.invoke(oidTable,args);

    res[key.intValue()]=val;
   }

   for(int i=0;i<res.length;i++) {
    if (res[i]!=null) {
     out.println("- ["+i+"] = "+res[i]);
    }
   }

   out.println("---------------- MAP TABLE ----------------");

   c=Class.forName("weblogic.jndi.internal.RootNamingNode");
   m=c.getMethod("getSingleton",new Class[0]);

   Object rnn=m.invoke(null,new Object[0]);

   server=null;
   dump_namingnode(out,rnn,0);

   c=server.getClass();

   m=c.getMethod("getServerName",new Class[0]);
   Object name=m.invoke(server,new Object[0]);

   out.println("name "+name);

   ctab=new Class[2];
   ctab[0]=Class.forName("javax.management.ObjectName");
   ctab[1]=Class.forName("javax.management.QueryExp");

   m=c.getMethod("queryMBeans",ctab);

   Object args[]=new Object[2];

   HashSet map=(HashSet)m.invoke(server,args);

   Iterator it=map.iterator();

   out.println("---------------- MBEANS ----------------");

   while(it.hasNext()) {
    Object key=it.next();
    String ss=""+key;

    out.println("- "+key);//+val);
   }

  } catch(Throwable t) {
   t.printStackTrace(out);
  }
 }
}
